/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Series } from "./Series";
import { IHasCategoryModePreference_$type } from "./IHasCategoryModePreference";
import { Axis } from "./Axis";
import { DependencyProperty } from "igniteui-react-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { Point_$type, typeCast, Delegate_$type, markType, markDep } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { Thickness } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { Dictionary$2 } from "igniteui-react-core";
import { Pool$1 } from "igniteui-react-core";
import { AxisAnnotation } from "./AxisAnnotation";
import { SeriesView } from "./SeriesView";
import { NotImplementedException } from "igniteui-react-core";
import { AxisRange } from "./AxisRange";
import { NumericAxisBase } from "./NumericAxisBase";
import { AxisAnnotationFrame } from "./AxisAnnotationFrame";
import { ScalerParams } from "./ScalerParams";
import { CategoryXAxis } from "./CategoryXAxis";
import { AxisAnnotationFrameManager } from "./AxisAnnotationFrameManager";
import { PropertyMetadata } from "igniteui-react-core";
import { DeviceUtils } from "igniteui-react-core";
import { isNaN_, isInfinity } from "igniteui-react-core";
import { stringFormat } from "igniteui-react-core";
import { Path } from "igniteui-react-core";
/**
 * @hidden
 */
var ValueOverlay = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ValueOverlay, _super);
    function ValueOverlay() {
        var _this = _super.call(this) || this;
        _this.w6 = 0;
        _this.w7 = 0;
        _this.w3 = 0;
        _this.wq = null;
        _this.ww = null;
        _this.wv = null;
        _this.ab = ValueOverlay.$;
        return _this;
    }
    ValueOverlay.prototype.bi = function () {
        return new ValueOverlay();
    };
    ValueOverlay.prototype.i3 = function (a, b, c) {
        return this.w8;
    };
    ValueOverlay.prototype.w4 = function (a, b) {
        var c = Math.sqrt(Math.pow(a.x - b.x, 2) + Math.pow(a.y - b.y, 2));
        var d = Math.acos((a.x - b.x) / c);
        if ((a.y - b.y) < 0) {
            d = (2 * Math.PI) - d;
        }
        return d;
    };
    ValueOverlay.prototype.v5 = function (a, b, c) {
        if (this.wp == null) {
            return { $type: Point_$type, x: NaN, y: NaN };
        }
        var d = this.w5();
        var e = NaN;
        var f = NaN;
        var g = NaN;
        var h = { $type: Point_$type, x: 0.5, y: 0.5 };
        var i = NaN;
        switch (this.wp.a2) {
            case 2:
                i = Math.sqrt(Math.pow(a.x - h.x, 2) + Math.pow(a.y - h.y, 2));
                g = d;
                e = h.x + Math.cos(g) * i;
                f = h.y + Math.sin(g) * i;
                f = this.ct.bx.top + this.ct.bx.height * (f - this.ct.by.top) / this.ct.by.height;
                e = this.ct.bx.left + this.ct.bx.width * (e - this.ct.by.left) / this.ct.by.width;
                break;
            case 0:
                e = d;
                f = a.y;
                f = this.ct.bx.top + this.ct.bx.height * (f - this.ct.by.top) / this.ct.by.height;
                break;
            case 1:
                f = d;
                e = a.x;
                e = this.ct.bx.left + this.ct.bx.width * (e - this.ct.by.left) / this.ct.by.width;
                break;
            case 3:
                g = this.w4(a, h);
                i = d;
                e = h.x + Math.cos(g) * i;
                f = h.y + Math.sin(g) * i;
                f = this.ct.bx.top + this.ct.bx.height * (f - this.ct.by.top) / this.ct.by.height;
                e = this.ct.bx.left + this.ct.bx.width * (e - this.ct.by.left) / this.ct.by.width;
                break;
        }
        return { $type: Point_$type, x: e, y: f };
    };
    ValueOverlay.prototype.j1 = function (a) {
        throw new NotImplementedException(0);
    };
    ValueOverlay.prototype.kl = function (a) {
        return this;
    };
    ValueOverlay.prototype.gb = function (a) {
        return false;
    };
    ValueOverlay.prototype.ax = function (a) {
        var b = typeCast(NumericAxisBase.$, a);
        var c = this.w8;
        if (isNaN_(c) || isInfinity(c)) {
            return null;
        }
        return new AxisRange(c, c);
    };
    ValueOverlay.prototype.rn = function (a) {
        this.o2(true, this.ct);
        if (!this.wu()) {
            if (this.wq != null) {
                this.xr(NaN, this.d1());
            }
            return;
        }
        if (this.gd(a)) {
            if (this.d1()) {
                if (this.da.g) {
                    this.da.t();
                }
                var b = this.w6;
                this.w6 = this.w7;
                this.w7 = b;
            }
            else {
                this.w6 = this.w3;
            }
            this.w3 = this.w5();
            this.r0();
        }
        else {
            this.w3 = this.w5();
            this.xq(this.w3, this.ws);
        }
    };
    ValueOverlay.prototype.w5 = function () {
        var a, b;
        var c = this.getViewInfo(b, a);
        b = c.p0;
        a = c.p1;
        var d = this.getEffectiveViewport1(this.ct);
        var e = new ScalerParams(0, a, b, this.wp.ch, d);
        return this.wp.ek(this.w8, e);
    };
    ValueOverlay.prototype.xq = function (a, b) {
        if (this.wp == null) {
            return;
        }
        var c = typeCast(CategoryAxisBase.$, this.wp);
        if (c != null && !c.ce) {
            if (this.w8 > c.lh - 1) {
                return;
            }
            if (c.categoryMode != 0) {
                var d = this.getEffectiveViewport1(b);
                var e = 0.5 * c.getCategorySize(b.by, b.bx, d);
                var f = false;
                if (c.cp && !c.ch) {
                    f = true;
                }
                if (typeCast(CategoryXAxis.$, c) !== null && c.ch) {
                    f = true;
                }
                if (f) {
                    e = -e;
                }
                a += e;
            }
        }
        var g = typeCast(NumericAxisBase.$, this.wp);
        if (g != null) {
            if (this.w8 < g.ly || this.w8 > g.lx) {
                return;
            }
            if (g.lk && this.w8 < 0) {
                return;
            }
        }
        var h;
        switch (this.wp.a2) {
            case 2:
            case 3:
                h = this.wp.j6(a, b.by, b.bx, this.getEffectiveViewport1(b), this.wc(b));
                break;
            default:
                h = this.wp.j6(a, b.by, b.bx, this.getEffectiveViewport1(b), this.wc(b));
                break;
        }
        if (h != null) {
            b.b1(h);
        }
        if (!b.q) {
            this.xr(a, this.d1());
        }
    };
    ValueOverlay.prototype.hc = function (a, b, c) {
        var d = true;
        d = _super.prototype.hc.call(this, a, b, c);
        if (!c.o() || b.isEmpty || a.isEmpty || this.wp == null || this.wp.bi == null) {
            d = false;
        }
        return d;
    };
    ValueOverlay.prototype.sk = function (a, b) {
        this.rm(false);
    };
    ValueOverlay.prototype.sj = function (a, b) {
        this.rm(false);
    };
    ValueOverlay.prototype.o8 = function (a, b, c, d) {
        throw new NotImplementedException(0);
    };
    ValueOverlay.prototype.q4 = function (a, b, c, d) {
        _super.prototype.q4.call(this, a, b, c, d);
        switch (b) {
            case ValueOverlay.$$p[11]:
                if (c != null) {
                    c.b0(this);
                }
                if (d != null) {
                    d.ct(this);
                }
                this.rm(false);
                this.qg();
                break;
            case "TransitionProgress":
                this.w7 = this.w6 + this.jo * (this.w3 - this.w6);
                if (this.d3(this.ct)) {
                    return;
                }
                if (this.jo == 1) {
                    this.xq(this.w3, this.ws);
                    this.qj();
                }
                else {
                    this.xq(this.w7, this.ws);
                }
                if (this.c9 != null) {
                    this.c9.qa(this);
                }
                break;
            case ValueOverlay.$$p[13]:
                var e = typeCast(NumericAxisBase.$, this.wp);
                if (e != null) {
                    e.c1();
                }
                this.rm(true);
                this.qh();
                break;
            case ValueOverlay.$$p[12]:
            case ValueOverlay.$$p[10]:
            case ValueOverlay.$$p[1]:
            case ValueOverlay.$$p[0]:
            case ValueOverlay.$$p[3]:
            case ValueOverlay.$$p[4]:
            case ValueOverlay.$$p[9]:
            case ValueOverlay.$$p[5]:
            case ValueOverlay.$$p[6]:
            case ValueOverlay.$$p[7]:
            case ValueOverlay.$$p[8]:
                this.rm(true);
                break;
        }
    };
    ValueOverlay.prototype.p5 = function () {
        _super.prototype.p5.call(this);
        if (this.wp != null) {
            this.wp.h9(false);
        }
    };
    ValueOverlay.prototype.o2 = function (a, b) {
        _super.prototype.o2.call(this, a, b);
        var c = b;
        c.b0();
    };
    ValueOverlay.prototype.wu = function () {
        if (this.wp == null || this.wp.bi == null || isNaN_(this.w8) || this._visibility != 0) {
            return false;
        }
        var a = typeCast(CategoryAxisBase.$, this.wp);
        if (a != null && a.lh == 0) {
            return false;
        }
        return true;
    };
    ValueOverlay.prototype.preferredCategoryMode = function (a) {
        return 0;
    };
    Object.defineProperty(ValueOverlay.prototype, "categoryAxis", {
        get: function () {
            return typeCast(CategoryAxisBase.$, this.wp);
        },
        enumerable: false,
        configurable: true
    });
    ValueOverlay.prototype.cq = function () {
        return new ValueOverlayView(this);
    };
    ValueOverlay.prototype.qw = function (a) {
        _super.prototype.qw.call(this, a);
        this.ws = typeCast(ValueOverlayView.$, a);
    };
    ValueOverlay.prototype.ro = function (a, b) {
        _super.prototype.ro.call(this, a, b);
        if (!this.gy) {
            this.ct.a4(b);
            return;
        }
        this.ct.a4(b);
        if (this.d3(this.cs) || !this.wu()) {
            return;
        }
        var c = this.getEffectiveViewport1(this.ct);
        var d = this.wp.ek(this.w8, new ScalerParams(0, this.cs.by, a, this.wp.ch, c));
        this.xq(d, typeCast(ValueOverlayView.$, this.cs));
        this.gy = false;
    };
    ValueOverlay.prototype.getOffsetValue = function () {
        return 0;
    };
    ValueOverlay.prototype.getCategoryWidth = function () {
        return 0;
    };
    Object.defineProperty(ValueOverlay.prototype, "x9", {
        get: function () {
            return new Thickness(1, this.wz, this.w1, this.w0, this.wy);
        },
        enumerable: false,
        configurable: true
    });
    ValueOverlay.prototype.ai = function () {
        return [this.wp];
    };
    ValueOverlay.prototype.xr = function (a, b) {
        if (isNaN_(a)) {
            if (this.wq != null) {
                AxisAnnotationFrameManager.b(this.wq);
                AxisAnnotationFrameManager.d(this, this.wq, true, this.wv, this.ww, b, this.w9, this.w9, this.wr, this.wr);
            }
            return;
        }
        var c = false;
        if (this.wv == null) {
            c = true;
            this.ww = new List$1(Axis.$, 0);
            this.wv = new Dictionary$2(Axis.$, Pool$1.$.specialize(AxisAnnotation.$), 0);
        }
        this.wq = new AxisAnnotationFrame();
        var d = this.u2;
        if (d == null) {
            d = this.u8;
        }
        var e = this.wp.cp;
        AxisAnnotationFrameManager.c(this.wq, { $type: Point_$type, x: a, y: a }, this, this.c9, this.getEffectiveViewport(), d, this.x6, this.wx, this.x8, this.x7, this.x9, this.w2, this.x6, this.wx, this.x8, this.x7, this.x9, this.w2, !e && this.wt, e && this.wt);
        AxisAnnotationFrameManager.d(this, this.wq, c, this.wv, this.ww, b, this.w9, this.w9, this.wr, this.wr);
    };
    ValueOverlay.prototype.get_isValueOverlay = function () {
        return true;
    };
    ValueOverlay.prototype.xm = function (a) {
        if (this.wp != null) {
            return this.wp.ge(a);
        }
        return null;
    };
    Object.defineProperty(ValueOverlay.prototype, "xo", {
        get: function () {
            var a = this.xm(this.w8);
            return a != null ? a : stringFormat("{0:0.##}", this.w8);
        },
        enumerable: false,
        configurable: true
    });
    ValueOverlay.$t = markType(ValueOverlay, 'ValueOverlay', Series.$, [IHasCategoryModePreference_$type]);
    ValueOverlay.$$p = markDep(DependencyProperty, PropertyMetadata, ValueOverlay, 'raisePropertyChanged', ['AxisAnnotationBackgroundCornerRadius:wx:xs', [1, DeviceUtils.g(3)], 'AxisAnnotationBackground:x6:xt', [Brush.$, null], 'AxisAnnotationFormatLabel:wr:xu', [Delegate_$type], 'AxisAnnotationInterpolatedValuePrecision:w9:xv', [1, -1], 'AxisAnnotationOutline:x7:xw', [Brush.$, null], 'AxisAnnotationPaddingBottom:wy:xx', [1, NaN], 'AxisAnnotationPaddingLeft:wz:xy', [1, NaN], 'AxisAnnotationPaddingRight:w0:xz', [1, NaN], 'AxisAnnotationPaddingTop:w1:x0', [1, NaN], 'AxisAnnotationStrokeThickness:w2:x1', [1, NaN], 'AxisAnnotationTextColor:x8:x2', [Brush.$, null], 'Axis:wp:x3', [Axis.$, null], 'IsAxisAnnotationEnabled:wt:x4', [0, false], 'Value:w8:x5', [1, 0]]);
    return ValueOverlay;
}(Series));
export { ValueOverlay };
/**
 * @hidden
 */
var ValueOverlayView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ValueOverlayView, _super);
    function ValueOverlayView(a) {
        var _this = _super.call(this, a) || this;
        _this.b2 = null;
        _this.b2 = new Path();
        return _this;
    }
    ValueOverlayView.prototype.bd = function () {
        _super.prototype.bd.call(this);
        this.b2._stroke = this.e.u2;
        this.b2.ad = this.e.ic;
        this.b2.ai = this.e.vv;
        this.b2.aj = this.e.vw;
    };
    ValueOverlayView.prototype.be = function () {
        _super.prototype.be.call(this);
        var a = this.br();
        this.b2._stroke = a;
        this.b2.ad = this.e.ic + 3;
        this.b2._stroke = a;
        this.b2.ad = this.e.ic + 3;
    };
    ValueOverlayView.prototype.b1 = function (a) {
        this.b2.an = a;
        this.as();
    };
    ValueOverlayView.prototype.b0 = function () {
        this.b2.an = null;
        this.as();
    };
    ValueOverlayView.prototype.a8 = function (a, b) {
        _super.prototype.a8.call(this, a, b);
        if (a.d) {
            a.t(this.b2);
        }
    };
    ValueOverlayView.prototype.an = function (a) {
        _super.prototype.an.call(this, a);
        this.e.bb.exportPathData(a, this.b2, "ValueOverlayPath", []);
    };
    ValueOverlayView.$t = markType(ValueOverlayView, 'ValueOverlayView', SeriesView.$);
    return ValueOverlayView;
}(SeriesView));
export { ValueOverlayView };
